﻿// Change this to the LCD/Text panel's name 
const string SCREEN_NAME = "GPS Screen"; 
 
// (OPTIONAL) The block that you want to get GPS coordinates from, preferably a block in the center of your ship 
// If left empty it will use the screen's position 
const string CENTER_BLOCK = ""; 
 
// the format of the text, leave as it is if you don't know what you're doing 
const string FORMAT = "X={0:0.00}\nY={1:0.00}\nZ={2:0.00}"; 
 
IMyTerminalBlock center = null; 
IMyTextPanel screen = null; 
 
void Main() 
{ 
    if(screen == null) 
    { 
        screen = GridTerminalSystem.GetBlockWithName(SCREEN_NAME) as IMyTextPanel; 
         
        if(screen == null) 
            throw new Exception("Can't find LCD/Text panel: " + SCREEN_NAME); 
    } 
     
    if(center == null) 
    { 
        if(CENTER_BLOCK == null || CENTER_BLOCK == "") 
        { 
            center = screen; 
        } 
        else 
        { 
            center = GridTerminalSystem.GetBlockWithName(CENTER_BLOCK); 
             
            if(center == null) 
                throw new Exception("Can't find block: " + CENTER_BLOCK); 
        } 
    } 
     
    var pos = center.GetPosition(); 
     
    screen.WritePublicText(String.Format(FORMAT, pos.GetDim(0), pos.GetDim(1), pos.GetDim(2)), false); 
     
    // required because of some bugs 
    screen.ShowTextureOnScreen(); 
    screen.ShowPublicTextOnScreen(); 
}